testsprite2.c File Reference
`#include <stdlib.h>`
`#include <stdio.h>`
`#include <time.h>`
`#include "SDL_test.h"`
`#include "SDL_test_common.h"`
Include dependency graph for testsprite2.c:

Go to the source code of this file.

## Macros

#define | NUM_SPRITES 100
#define | MAX_SPEED 1

## Functions

static void | quit (int rc)
int | LoadSprite (const char *file)
void | MoveSprites (SDL_Renderer *renderer, SDL_Texture *sprite)
void | loop ()
int | main (int argc, char *argv[])

## Variables

static SDLTest_CommonState * | state
static int | num_sprites
static SDL_Texture ** | sprites
static SDL_bool | cycle_color
static SDL_bool | cycle_alpha
static int | cycle_direction = 1
static int | current_alpha = 0
static int | current_color = 0
static SDL_Rect * | positions
static SDL_Rect * | velocities
static int | sprite_w
static int | sprite_h
static SDL_BlendMode | blendMode = SDL_BLENDMODE_BLEND
static int | iterations = -1
int | done

## Macro Definition Documentation

## MAX_SPEED

#define MAX_SPEED 1

Definition at line 26 of file testsprite2.c.

Referenced by main().

## NUM_SPRITES

#define NUM_SPRITES 100

Definition at line 25 of file testsprite2.c.

Referenced by main().

## Function Documentation

## LoadSprite()

int LoadSprite | ( | const char * | file | ) |

Definition at line 59 of file testsprite2.c.

References SDL_PixelFormat::BitsPerPixel, blendMode, SDL_Surface::format, SDL_Surface::h, i, NULL, SDLTest_CommonState::num_windows, SDL_PixelFormat::palette, SDL_Surface::pixels, renderer, SDLTest_CommonState::renderers, SDL_CreateTextureFromSurface, SDL_DestroyTexture, SDL_FreeSurface, SDL_GetError, SDL_LoadBMP, SDL_LOG_CATEGORY_APPLICATION, SDL_LogError, SDL_SetColorKey, SDL_SetTextureBlendMode, sprite_h, sprite_w, and SDL_Surface::w.

Referenced by main().

{
int i;
SDL_Surface *temp;
/* Load the sprite image */
temp = SDL_LoadBMP(file);
if (temp == NULL) {
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "Couldn't load %s: %s", file, SDL_GetError());
return (-1);
}
sprite_w = temp->w;
sprite_h = temp->h;
/* Set transparent pixel as the pixel at (0,0) */
if (temp->format->palette) {
SDL_SetColorKey(temp, 1, *(Uint8 *) temp->pixels);
} else {
switch (temp->format->BitsPerPixel) {
case 15:
SDL_SetColorKey(temp, 1, (*(Uint16 *) temp->pixels) & 0x00007FFF);
break;
case 16:
SDL_SetColorKey(temp, 1, *(Uint16 *) temp->pixels);
break;
case 24:
SDL_SetColorKey(temp, 1, (*(Uint32 *) temp->pixels) & 0x00FFFFFF);
break;
case 32:
SDL_SetColorKey(temp, 1, *(Uint32 *) temp->pixels);
break;
}
}
/* Create textures from the image */
for (i = 0; i < state->num_windows; ++i) {
SDL_Renderer *renderer = state->renderers[i];
sprites[i] = SDL_CreateTextureFromSurface(renderer, temp);
if (!sprites[i]) {
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "Couldn't create texture: %s\n", SDL_GetError());
SDL_FreeSurface(temp);
return (-1);
}
if (SDL_SetTextureBlendMode(sprites[i], blendMode) < 0) {
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "Couldn't set blend mode: %s\n", SDL_GetError());
SDL_FreeSurface(temp);
SDL_DestroyTexture(sprites[i]);
return (-1);
}
}
SDL_FreeSurface(temp);
/* We're ready to roll. :) */
return (0);
}
SDL_GetError
#define SDL_GetError
Definition: SDL_dynapi_overrides.h:113
sprites
static SDL_Texture ** sprites
Definition: testsprite2.c:30
SDL_Surface::h
int h
Definition: SDL_surface.h:73
SDL_LoadBMP
#define SDL_LoadBMP(file)
Definition: SDL_surface.h:200
SDL_Surface
A collection of pixels used in software blitting.
Definition: SDL_surface.h:69
SDL_SetTextureBlendMode
#define SDL_SetTextureBlendMode
Definition: SDL_dynapi_overrides.h:313
SDL_Renderer
Definition: SDL_sysrender.h:76
sprite_h
static int sprite_h
Definition: testsprite2.c:38
state
static SDLTest_CommonState * state
Definition: testsprite2.c:28
Uint32
uint32_t Uint32
Definition: SDL_stdinc.h:181
SDL_Surface::w
int w
Definition: SDL_surface.h:73
SDL_LogError
#define SDL_LogError
Definition: SDL_dynapi_overrides.h:36
SDLTest_CommonState::num_windows
int num_windows
Definition: SDL_test_common.h:77
SDL_CreateTextureFromSurface
#define SDL_CreateTextureFromSurface
Definition: SDL_dynapi_overrides.h:307
SDL_Surface::pixels
void * pixels
Definition: SDL_surface.h:75
SDL_FreeSurface
#define SDL_FreeSurface
Definition: SDL_dynapi_overrides.h:446
renderer
static SDL_Renderer * renderer
Definition: testaudiocapture.c:21
Uint8
uint8_t Uint8
Definition: SDL_stdinc.h:157
SDL_PixelFormat::BitsPerPixel
Uint8 BitsPerPixel
Definition: SDL_pixels.h:319
sprite_w
static int sprite_w
Definition: testsprite2.c:38
SDL_SetColorKey
#define SDL_SetColorKey
Definition: SDL_dynapi_overrides.h:453
SDLTest_CommonState::renderers
SDL_Renderer ** renderers
Definition: SDL_test_common.h:84
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
NULL
#define NULL
Definition: begin_code.h:164
SDL_Surface::format
SDL_PixelFormat * format
Definition: SDL_surface.h:72
SDL_DestroyTexture
#define SDL_DestroyTexture
Definition: SDL_dynapi_overrides.h:347
Uint16
uint16_t Uint16
Definition: SDL_stdinc.h:169
SDL_PixelFormat::palette
SDL_Palette * palette
Definition: SDL_pixels.h:318
blendMode
static SDL_BlendMode blendMode
Definition: testsprite2.c:39
SDL_LOG_CATEGORY_APPLICATION
Definition: SDL_log.h:66

## loop()

void loop | ( |  | ) |

Definition at line 245 of file testsprite2.c.

References done, i, MoveSprites(), NULL, SDLTest_CommonState::num_windows, SDLTest_CommonState::renderers, SDL_PollEvent, SDLTest_CommonEvent(), and SDLTest_CommonState::windows.

Referenced by main().

{
int i;
SDL_Event event;
/* Check for events */
while (SDL_PollEvent(&event)) {
SDLTest_CommonEvent(state, &event, &done);
}
for (i = 0; i < state->num_windows; ++i) {
if (state->windows[i] == NULL)
continue;
MoveSprites(state->renderers[i], sprites[i]);
}
#ifdef __EMSCRIPTEN__
if (done) {
emscripten_cancel_main_loop();
}
#endif
}
SDL_PollEvent
#define SDL_PollEvent
Definition: SDL_dynapi_overrides.h:122
sprites
static SDL_Texture ** sprites
Definition: testsprite2.c:30
state
static SDLTest_CommonState * state
Definition: testsprite2.c:28
done
int done
Definition: testsprite2.c:45
SDLTest_CommonState::windows
SDL_Window ** windows
Definition: SDL_test_common.h:78
SDLTest_CommonState::num_windows
int num_windows
Definition: SDL_test_common.h:77
SDLTest_CommonEvent
void SDLTest_CommonEvent(SDLTest_CommonState *state, SDL_Event *event, int *done)
Common event handler for test windows.
Definition: SDL_test_common.c:1425
event
struct _cl_event * event
Definition: SDL_opengl_glext.h:2649
SDLTest_CommonState::renderers
SDL_Renderer ** renderers
Definition: SDL_test_common.h:84
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
NULL
#define NULL
Definition: begin_code.h:164
SDL_Event
General event structure.
Definition: SDL_events.h:525
MoveSprites
void MoveSprites(SDL_Renderer *renderer, SDL_Texture *sprite)
Definition: testsprite2.c:116

## main()

int main | ( | int | argc,
|  | char * | argv[]
| ) |  |

Definition at line 267 of file testsprite2.c.

References blendMode, cycle_alpha, cycle_color, done, SDL_Rect::h, i, iterations, LoadSprite(), loop(), MAX_SPEED, NULL, NUM_SPRITES, num_sprites, SDLTest_CommonState::num_windows, quit(), renderer, SDLTest_CommonState::renderers, SDL_atoi, SDL_BLENDFACTOR_ONE, SDL_BLENDFACTOR_SRC_ALPHA, SDL_BLENDFACTOR_ZERO, SDL_BLENDMODE_ADD, SDL_BLENDMODE_BLEND, SDL_BLENDMODE_MOD, SDL_BLENDMODE_NONE, SDL_BLENDOPERATION_SUBTRACT, SDL_ComposeCustomBlendMode, SDL_GetTicks(), SDL_INIT_VIDEO, SDL_isdigit, SDL_Log, SDL_LOG_CATEGORY_APPLICATION, SDL_LogError, SDL_malloc, SDL_RenderClear, SDL_SetRenderDrawColor, SDL_strcasecmp, SDL_TRUE, SDLTest_CommonArg(), SDLTest_CommonCreateState(), SDLTest_CommonInit(), SDLTest_CommonUsage(), SDLTest_FuzzerInit(), SDLTest_RandomIntegerInRange(), sprite_h, sprite_w, SDL_Rect::w, SDLTest_CommonState::window_h, SDLTest_CommonState::window_w, SDL_Rect::x, and SDL_Rect::y.

{
int i;
Uint32 then, now, frames;
Uint64 seed;
const char *icon = "icon.bmp";
/* Initialize parameters */
num_sprites = NUM_SPRITES;
/* Initialize test framework */
state = SDLTest_CommonCreateState(argv, SDL_INIT_VIDEO);
if (!state) {
return 1;
}
for (i = 1; i < argc;) {
int consumed;
consumed = SDLTest_CommonArg(state, i);
if (consumed == 0) {
consumed = -1;
if (SDL_strcasecmp(argv[i], "--blend") == 0) {
if (argv[i + 1]) {
if (SDL_strcasecmp(argv[i + 1], "none") == 0) {
blendMode = SDL_BLENDMODE_NONE;
consumed = 2;
} else if (SDL_strcasecmp(argv[i + 1], "blend") == 0) {
blendMode = SDL_BLENDMODE_BLEND;
consumed = 2;
} else if (SDL_strcasecmp(argv[i + 1], "add") == 0) {
blendMode = SDL_BLENDMODE_ADD;
consumed = 2;
} else if (SDL_strcasecmp(argv[i + 1], "mod") == 0) {
blendMode = SDL_BLENDMODE_MOD;
consumed = 2;
} else if (SDL_strcasecmp(argv[i + 1], "sub") == 0) {
blendMode = SDL_ComposeCustomBlendMode(SDL_BLENDFACTOR_SRC_ALPHA, SDL_BLENDFACTOR_ONE, SDL_BLENDOPERATION_SUBTRACT, SDL_BLENDFACTOR_ZERO, SDL_BLENDFACTOR_ONE, SDL_BLENDOPERATION_SUBTRACT);
consumed = 2;
}
}
} else if (SDL_strcasecmp(argv[i], "--iterations") == 0) {
if (argv[i + 1]) {
iterations = SDL_atoi(argv[i + 1]);
if (iterations < -1) iterations = -1;
consumed = 2;
}
} else if (SDL_strcasecmp(argv[i], "--cyclecolor") == 0) {
cycle_color = SDL_TRUE;
consumed = 1;
} else if (SDL_strcasecmp(argv[i], "--cyclealpha") == 0) {
cycle_alpha = SDL_TRUE;
consumed = 1;
} else if (SDL_isdigit(*argv[i])) {
num_sprites = SDL_atoi(argv[i]);
consumed = 1;
} else if (argv[i][0] != '-') {
icon = argv[i];
consumed = 1;
}
}
if (consumed < 0) {
SDL_Log("Usage: %s %s [--blend none|blend|add|mod] [--cyclecolor] [--cyclealpha] [--iterations N] [num_sprites] [icon.bmp]\n",
argv[0], SDLTest_CommonUsage(state));
quit(1);
}
i += consumed;
}
if (!SDLTest_CommonInit(state)) {
quit(2);
}
/* Create the windows, initialize the renderers, and load the textures */
sprites =
(SDL_Texture **) SDL_malloc(state->num_windows * sizeof(*sprites));
if (!sprites) {
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "Out of memory!\n");
quit(2);
}
for (i = 0; i < state->num_windows; ++i) {
SDL_Renderer *renderer = state->renderers[i];
SDL_SetRenderDrawColor(renderer, 0xA0, 0xA0, 0xA0, 0xFF);
SDL_RenderClear(renderer);
}
if (LoadSprite(icon) < 0) {
quit(2);
}
/* Allocate memory for the sprite info */
positions = (SDL_Rect *) SDL_malloc(num_sprites * sizeof(SDL_Rect));
velocities = (SDL_Rect *) SDL_malloc(num_sprites * sizeof(SDL_Rect));
if (!positions || !velocities) {
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "Out of memory!\n");
quit(2);
}
/* Position sprites and set their velocities using the fuzzer */
if (iterations >= 0) {
/* Deterministic seed - used for visual tests */
seed = (Uint64)iterations;
} else {
/* Pseudo-random seed generated from the time */
seed = (Uint64)time(NULL);
}
SDLTest_FuzzerInit(seed);
for (i = 0; i < num_sprites; ++i) {
positions[i].x = SDLTest_RandomIntegerInRange(0, state->window_w - sprite_w);
positions[i].y = SDLTest_RandomIntegerInRange(0, state->window_h - sprite_h);
positions[i].w = sprite_w;
positions[i].h = sprite_h;
velocities[i].x = 0;
velocities[i].y = 0;
while (!velocities[i].x && !velocities[i].y) {
velocities[i].x = SDLTest_RandomIntegerInRange(-MAX_SPEED, MAX_SPEED);
velocities[i].y = SDLTest_RandomIntegerInRange(-MAX_SPEED, MAX_SPEED);
}
}
/* Main render loop */
frames = 0;
then = SDL_GetTicks();
done = 0;
#ifdef __EMSCRIPTEN__
emscripten_set_main_loop(loop, 0, 1);
#else
while (!done) {
++frames;
loop();
}
#endif
/* Print out some timing information */
now = SDL_GetTicks();
if (now > then) {
double fps = ((double) frames * 1000) / (now - then);
SDL_Log("%2.2f frames per second\n", fps);
}
quit(0);
return 0;
}
quit
static void quit(int rc)
Definition: testsprite2.c:49
sprites
static SDL_Texture ** sprites
Definition: testsprite2.c:30
SDL_TRUE
Definition: SDL_stdinc.h:142
time
EGLSurface EGLnsecsANDROID time
Definition: eglext.h:518
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
SDL_BLENDMODE_NONE
Definition: SDL_blendmode.h:42
SDLTest_RandomIntegerInRange
Sint32 SDLTest_RandomIntegerInRange(Sint32 min, Sint32 max)
Definition: SDL_test_fuzzer.c:163
velocities
static SDL_Rect * velocities
Definition: testsprite2.c:37
SDLTest_CommonCreateState
SDLTest_CommonState * SDLTest_CommonCreateState(char **argv, Uint32 flags)
Parse command line parameters and create common state.
Definition: SDL_test_common.c:48
NUM_SPRITES
#define NUM_SPRITES
Definition: testsprite2.c:25
SDLTest_CommonArg
int SDLTest_CommonArg(SDLTest_CommonState *state, int index)
Process one common argument.
Definition: SDL_test_common.c:106
SDLTest_CommonState::window_w
int window_w
Definition: SDL_test_common.h:66
cycle_color
static SDL_bool cycle_color
Definition: testsprite2.c:31
SDL_Renderer
Definition: SDL_sysrender.h:76
sprite_h
static int sprite_h
Definition: testsprite2.c:38
iterations
static int iterations
Definition: testsprite2.c:43
state
static SDLTest_CommonState * state
Definition: testsprite2.c:28
Uint32
uint32_t Uint32
Definition: SDL_stdinc.h:181
done
int done
Definition: testsprite2.c:45
SDL_strcasecmp
#define SDL_strcasecmp
Definition: SDL_dynapi_overrides.h:419
SDLTest_CommonInit
SDL_bool SDLTest_CommonInit(SDLTest_CommonState *state)
Open test window.
Definition: SDL_test_common.c:726
Uint64
uint64_t Uint64
Definition: SDL_stdinc.h:194
SDL_Texture
Definition: SDL_sysrender.h:49
SDL_BLENDMODE_MOD
Definition: SDL_blendmode.h:50
num_sprites
static int num_sprites
Definition: testsprite2.c:29
MAX_SPEED
#define MAX_SPEED
Definition: testsprite2.c:26
SDL_LogError
#define SDL_LogError
Definition: SDL_dynapi_overrides.h:36
SDLTest_CommonState::num_windows
int num_windows
Definition: SDL_test_common.h:77
SDL_Log
#define SDL_Log
Definition: SDL_dynapi_overrides.h:31
LoadSprite
int LoadSprite(const char *file)
Definition: testsprite2.c:59
SDL_isdigit
#define SDL_isdigit
Definition: SDL_dynapi_overrides.h:382
SDL_GetTicks
Uint32 SDL_GetTicks(void)
Get the number of milliseconds since the SDL library initialization.
renderer
static SDL_Renderer * renderer
Definition: testaudiocapture.c:21
sprite_w
static int sprite_w
Definition: testsprite2.c:38
SDLTest_CommonState::window_h
int window_h
Definition: SDL_test_common.h:67
SDL_BLENDFACTOR_SRC_ALPHA
Definition: SDL_blendmode.h:81
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1574
SDL_Rect::x
int x
Definition: SDL_rect.h:66
SDLTest_CommonUsage
const char * SDLTest_CommonUsage(SDLTest_CommonState *state)
Returns common usage information.
Definition: SDL_test_common.c:478
SDL_Rect::w
int w
Definition: SDL_rect.h:67
SDL_atoi
#define SDL_atoi
Definition: SDL_dynapi_overrides.h:410
cycle_alpha
static SDL_bool cycle_alpha
Definition: testsprite2.c:32
SDLTest_CommonState::renderers
SDL_Renderer ** renderers
Definition: SDL_test_common.h:84
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
SDL_BLENDFACTOR_ONE
Definition: SDL_blendmode.h:78
NULL
#define NULL
Definition: begin_code.h:164
SDL_BLENDOPERATION_SUBTRACT
Definition: SDL_blendmode.h:65
SDL_ComposeCustomBlendMode
#define SDL_ComposeCustomBlendMode
Definition: SDL_dynapi_overrides.h:630
SDL_RenderClear
#define SDL_RenderClear
Definition: SDL_dynapi_overrides.h:334
SDL_BLENDFACTOR_ZERO
Definition: SDL_blendmode.h:77
SDL_Rect::h
int h
Definition: SDL_rect.h:67
SDL_BLENDMODE_ADD
Definition: SDL_blendmode.h:47
positions
static SDL_Rect * positions
Definition: testsprite2.c:36
SDL_malloc
#define SDL_malloc
Definition: SDL_dynapi_overrides.h:374
SDL_SetRenderDrawColor
#define SDL_SetRenderDrawColor
Definition: SDL_dynapi_overrides.h:330
SDLTest_FuzzerInit
void SDLTest_FuzzerInit(Uint64 execKey)
Definition: SDL_test_fuzzer.c:63
blendMode
static SDL_BlendMode blendMode
Definition: testsprite2.c:39
loop
void loop()
Definition: testsprite2.c:245
SDL_LOG_CATEGORY_APPLICATION
Definition: SDL_log.h:66
SDL_Rect::y
int y
Definition: SDL_rect.h:66
SDL_INIT_VIDEO
#define SDL_INIT_VIDEO
Definition: SDL.h:78
SDL_Rect
A rectangle, with the origin at the upper left.
Definition: SDL_rect.h:64
SDL_BLENDMODE_BLEND
Definition: SDL_blendmode.h:44

## MoveSprites()

void MoveSprites | ( | SDL_Renderer * | renderer,
|  | SDL_Texture * | sprite
| ) |  |

Definition at line 116 of file testsprite2.c.

References current_alpha, current_color, cycle_alpha, cycle_color, cycle_direction, SDL_Rect::h, i, iterations, NULL, num_sprites, SDL_FALSE, SDL_RenderClear, SDL_RenderCopy, SDL_RenderDrawLine, SDL_RenderDrawPoint, SDL_RenderFillRect, SDL_RenderGetViewport, SDL_RenderPresent, SDL_SetRenderDrawColor, SDL_SetTextureAlphaMod, SDL_SetTextureColorMod, sprite_h, sprite_w, viewport, SDL_Rect::w, SDL_Rect::x, and SDL_Rect::y.

Referenced by loop().

{
int i;
SDL_Rect viewport, temp;
SDL_Rect *position, *velocity;
/* Query the sizes */
SDL_RenderGetViewport(renderer, &viewport);
/* Cycle the color and alpha, if desired */
if (cycle_color) {
current_color += cycle_direction;
if (current_color < 0) {
current_color = 0;
cycle_direction = -cycle_direction;
}
if (current_color > 255) {
current_color = 255;
cycle_direction = -cycle_direction;
}
SDL_SetTextureColorMod(sprite, 255, (Uint8) current_color,
(Uint8) current_color);
}
if (cycle_alpha) {
current_alpha += cycle_direction;
if (current_alpha < 0) {
current_alpha = 0;
cycle_direction = -cycle_direction;
}
if (current_alpha > 255) {
current_alpha = 255;
cycle_direction = -cycle_direction;
}
SDL_SetTextureAlphaMod(sprite, (Uint8) current_alpha);
}
/* Draw a gray background */
SDL_SetRenderDrawColor(renderer, 0xA0, 0xA0, 0xA0, 0xFF);
SDL_RenderClear(renderer);
/* Test points */
SDL_SetRenderDrawColor(renderer, 0xFF, 0x00, 0x00, 0xFF);
SDL_RenderDrawPoint(renderer, 0, 0);
SDL_RenderDrawPoint(renderer, viewport.w-1, 0);
SDL_RenderDrawPoint(renderer, 0, viewport.h-1);
SDL_RenderDrawPoint(renderer, viewport.w-1, viewport.h-1);
/* Test horizontal and vertical lines */
SDL_SetRenderDrawColor(renderer, 0x00, 0xFF, 0x00, 0xFF);
SDL_RenderDrawLine(renderer, 1, 0, viewport.w-2, 0);
SDL_RenderDrawLine(renderer, 1, viewport.h-1, viewport.w-2, viewport.h-1);
SDL_RenderDrawLine(renderer, 0, 1, 0, viewport.h-2);
SDL_RenderDrawLine(renderer, viewport.w-1, 1, viewport.w-1, viewport.h-2);
/* Test fill and copy */
SDL_SetRenderDrawColor(renderer, 0xFF, 0xFF, 0xFF, 0xFF);
temp.x = 1;
temp.y = 1;
temp.w = sprite_w;
temp.h = sprite_h;
SDL_RenderFillRect(renderer, &temp);
SDL_RenderCopy(renderer, sprite, NULL, &temp);
temp.x = viewport.w-sprite_w-1;
temp.y = 1;
temp.w = sprite_w;
temp.h = sprite_h;
SDL_RenderFillRect(renderer, &temp);
SDL_RenderCopy(renderer, sprite, NULL, &temp);
temp.x = 1;
temp.y = viewport.h-sprite_h-1;
temp.w = sprite_w;
temp.h = sprite_h;
SDL_RenderFillRect(renderer, &temp);
SDL_RenderCopy(renderer, sprite, NULL, &temp);
temp.x = viewport.w-sprite_w-1;
temp.y = viewport.h-sprite_h-1;
temp.w = sprite_w;
temp.h = sprite_h;
SDL_RenderFillRect(renderer, &temp);
SDL_RenderCopy(renderer, sprite, NULL, &temp);
/* Test diagonal lines */
SDL_SetRenderDrawColor(renderer, 0x00, 0xFF, 0x00, 0xFF);
SDL_RenderDrawLine(renderer, sprite_w, sprite_h,
viewport.w-sprite_w-2, viewport.h-sprite_h-2);
SDL_RenderDrawLine(renderer, viewport.w-sprite_w-2, sprite_h,
sprite_w, viewport.h-sprite_h-2);
/* Conditionally move the sprites, bounce at the wall */
if (iterations == -1 || iterations > 0) {
for (i = 0; i < num_sprites; ++i) {
position = &positions[i];
velocity = &velocities[i];
position->x += velocity->x;
if ((position->x < 0) || (position->x >= (viewport.w - sprite_w))) {
velocity->x = -velocity->x;
position->x += velocity->x;
}
position->y += velocity->y;
if ((position->y < 0) || (position->y >= (viewport.h - sprite_h))) {
velocity->y = -velocity->y;
position->y += velocity->y;
}
}
/* Countdown sprite-move iterations and disable color changes at iteration end - used for visual tests. */
if (iterations > 0) {
iterations--;
if (iterations == 0) {
cycle_alpha = SDL_FALSE;
cycle_color = SDL_FALSE;
}
}
}
/* Draw sprites */
for (i = 0; i < num_sprites; ++i) {
position = &positions[i];
/* Blit the sprite onto the screen */
SDL_RenderCopy(renderer, sprite, NULL, position);
}
/* Update the screen! */
SDL_RenderPresent(renderer);
}
SDL_RenderDrawPoint
#define SDL_RenderDrawPoint
Definition: SDL_dynapi_overrides.h:335
velocities
static SDL_Rect * velocities
Definition: testsprite2.c:37
SDL_FALSE
Definition: SDL_stdinc.h:141
SDL_RenderFillRect
#define SDL_RenderFillRect
Definition: SDL_dynapi_overrides.h:341
cycle_color
static SDL_bool cycle_color
Definition: testsprite2.c:31
sprite_h
static int sprite_h
Definition: testsprite2.c:38
iterations
static int iterations
Definition: testsprite2.c:43
num_sprites
static int num_sprites
Definition: testsprite2.c:29
SDL_RenderCopy
#define SDL_RenderCopy
Definition: SDL_dynapi_overrides.h:343
Uint8
uint8_t Uint8
Definition: SDL_stdinc.h:157
current_alpha
static int current_alpha
Definition: testsprite2.c:34
sprite_w
static int sprite_w
Definition: testsprite2.c:38
SDL_RenderGetViewport
#define SDL_RenderGetViewport
Definition: SDL_dynapi_overrides.h:325
SDL_SetTextureColorMod
#define SDL_SetTextureColorMod
Definition: SDL_dynapi_overrides.h:309
SDL_Rect::x
int x
Definition: SDL_rect.h:66
SDL_Rect::w
int w
Definition: SDL_rect.h:67
cycle_alpha
static SDL_bool cycle_alpha
Definition: testsprite2.c:32
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
NULL
#define NULL
Definition: begin_code.h:164
SDL_RenderClear
#define SDL_RenderClear
Definition: SDL_dynapi_overrides.h:334
SDL_Rect::h
int h
Definition: SDL_rect.h:67
viewport
SDL_Rect viewport
Definition: testviewport.c:28
positions
static SDL_Rect * positions
Definition: testsprite2.c:36
SDL_SetRenderDrawColor
#define SDL_SetRenderDrawColor
Definition: SDL_dynapi_overrides.h:330
cycle_direction
static int cycle_direction
Definition: testsprite2.c:33
current_color
static int current_color
Definition: testsprite2.c:35
SDL_RenderDrawLine
#define SDL_RenderDrawLine
Definition: SDL_dynapi_overrides.h:337
SDL_Rect::y
int y
Definition: SDL_rect.h:66
SDL_Rect
A rectangle, with the origin at the upper left.
Definition: SDL_rect.h:64
SDL_RenderPresent
#define SDL_RenderPresent
Definition: SDL_dynapi_overrides.h:346
SDL_SetTextureAlphaMod
#define SDL_SetTextureAlphaMod
Definition: SDL_dynapi_overrides.h:311

## quit()

static void quit | ( | int | rc | ) |

static

Definition at line 49 of file testsprite2.c.

References SDL_free, and SDLTest_CommonQuit().

Referenced by main().

{
SDL_free(sprites);
SDL_free(positions);
SDL_free(velocities);
SDLTest_CommonQuit(state);
exit(rc);
}
sprites
static SDL_Texture ** sprites
Definition: testsprite2.c:30
velocities
static SDL_Rect * velocities
Definition: testsprite2.c:37
state
static SDLTest_CommonState * state
Definition: testsprite2.c:28
SDL_free
#define SDL_free
Definition: SDL_dynapi_overrides.h:377
positions
static SDL_Rect * positions
Definition: testsprite2.c:36
SDLTest_CommonQuit
void SDLTest_CommonQuit(SDLTest_CommonState *state)
Close test window.
Definition: SDL_test_common.c:1751

## Variable Documentation

## blendMode

SDL_BlendMode blendMode = SDL_BLENDMODE_BLEND

static

Definition at line 39 of file testsprite2.c.

Referenced by LoadSprite(), and main().

## current_alpha

int current_alpha = 0

static

Definition at line 34 of file testsprite2.c.

Referenced by MoveSprites().

## current_color

int current_color = 0

static

Definition at line 35 of file testsprite2.c.

Referenced by MoveSprites().

## cycle_alpha

SDL_bool cycle_alpha

static

Definition at line 32 of file testsprite2.c.

Referenced by main(), and MoveSprites().

## cycle_color

SDL_bool cycle_color

static

Definition at line 31 of file testsprite2.c.

Referenced by main(), and MoveSprites().

## cycle_direction

int cycle_direction = 1

static

Definition at line 33 of file testsprite2.c.

Referenced by MoveSprites().

## done

int done

Definition at line 45 of file testsprite2.c.

Referenced by loop(), and main().

## iterations

int iterations = -1

static

Definition at line 43 of file testsprite2.c.

Referenced by main(), and MoveSprites().

## num_sprites

int num_sprites

static

Definition at line 29 of file testsprite2.c.

Referenced by main(), and MoveSprites().

## positions

SDL_Rect* positions

static

Definition at line 36 of file testsprite2.c.

## sprite_h

int sprite_h

static

Definition at line 38 of file testsprite2.c.

Referenced by LoadSprite(), main(), and MoveSprites().

## sprite_w

int sprite_w

static

Definition at line 38 of file testsprite2.c.

Referenced by LoadSprite(), main(), and MoveSprites().

## sprites

SDL_Texture** sprites

static

Definition at line 30 of file testsprite2.c.

## state

SDLTest_CommonState* state

static

Definition at line 28 of file testsprite2.c.

## velocities

SDL_Rect* velocities

static

Definition at line 37 of file testsprite2.c.